Attribute VB_Name = "MEntryPoints"
'Module: MEntryPoints
Option Explicit
 
Sub ShowTagForm()
    
    Dim ufTag As UTags
    Dim mi As MailItem
    Dim sTag As String
    Dim lFlagColor As Long
    Dim fldTag As MAPIFolder
    
    On Error Resume Next
        Set mi = Application.ActiveExplorer.Selection.Item(1)
    On Error GoTo 0
    
    If Not mi Is Nothing Then
        
        Set ufTag = New UTags
        
        'pass info to userform
        ufTag.Subject = mi.Subject
        ufTag.Unread = mi.Unread
        
        'show userform
        ufTag.Show
        
        'get info back from userform
        If Not ufTag.UserCancel Then
            sTag = ufTag.xTag
            If ufTag.Flag Then lFlagColor = ufTag.FlagColor
                    
            mi.FlagStatus = olFlagMarked
            mi.FlagIcon = lFlagColor
                                
            'move item to folder
            With Application.GetNamespace("MAPI")
                Set fldTag = GetOrCreateFldr(.GetDefaultFolder(olFolderInbox), sTag)
                mi.Move fldTag
            End With
             
        End If
        
    Else
        MsgBox "No Email Selected"
    End If
    
    Set ufTag = Nothing
    
End Sub
 
Private Function GetOrCreateFldr(fMain As MAPIFolder, sTag As String) As MAPIFolder
    
    Dim fSub As MAPIFolder
    Dim fEnd As MAPIFolder
    
    Set fEnd = CheckSubs(fMain, sTag)
    
    If Not fEnd Is Nothing Then
        Set GetOrCreateFldr = fEnd
    Else
        Set GetOrCreateFldr = fMain.Folders.Add(StrConv(sTag, vbProperCase))
    End If
    
End Function
 
Private Function CheckSubs(fSub As MAPIFolder, sTag As String) As MAPIFolder
    
    Dim fldr As MAPIFolder
    Dim fEnd As MAPIFolder
    
    For Each fldr In fSub.Folders
        If UCase(fldr.Name) = UCase(sTag) Then
            Set CheckSubs = fldr
            Exit Function
        Else
            If fldr.Folders.Count > 0 Then
                Set fEnd = CheckSubs(fldr, sTag)
                If Not fEnd Is Nothing Then
                    Set CheckSubs = fEnd
                    Exit Function
                End If
            End If
        End If
    Next fldr
    
End Function
